
double _ask;
double _bid;
bool bStart = TRUE;
extern bool Autolot = FALSE;
extern double Lot = 0.1;
extern bool Night = TRUE;

int start() {
   CloseAll();
   return (0);
}

void CloseAll() {
   double price;
   for (int pos = OrdersTotal() - 1; pos >= 0; pos--) {
      OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == 777) {
         if (NormalizeDouble(Bid, Digits) - OrderOpenPrice() >= 1.0 * Point)
            if (OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), 1, CLR_NONE);
         if (OrderOpenPrice() - NormalizeDouble(Ask, Digits) >= 1.0 * Point)
            if (OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), 1, CLR_NONE);
      }
   }
   if (bStart) {
      _ask = Ask;
      _bid = Bid;
      bStart = FALSE;
      return;
   }
   int spread = MarketInfo("Symbol", MODE_SPREAD);
   if ((Hour() >= 23 || Hour() <= 7 && Night == TRUE) || Night == FALSE) {
      if (Ask - _ask >= (spread + 1) * Point) {
         price = Bid + 20.0 * Point;
         OrderSend(Symbol(), OP_SELL, GetLots(), NormalizeDouble(Bid, Digits), 2, price, 0, 0, 777, 0, CLR_NONE);
      }
      if (_bid - Bid >= (spread + 1) * Point) {
         price = Ask - 20.0 * Point;
        OrderSend(Symbol(), OP_BUY, GetLots(), NormalizeDouble(Ask, Digits), 2, price, 0, 0, 777, 0, CLR_NONE);
      }
   }
   _ask = Ask;
   _bid = Bid;
}

double GetLots() {
   double ret;
   if (Autolot == FALSE) return (Lot);
   if (AccountBalance() > 100.0) ret = MathRound(15.0 * (AccountBalance() / 100.0) / 100.0) / 10.0;
   else ret = 0.1;
   return (ret);
}